asm deadlock

import StandardLibrary

signature:
	domain Station subsetof Integer
	domain Train subsetof Natural
	domain Constraint subsetof Integer

	monitored ct: Train

	controlled p: Seq(Natural)
	controlled ra: Integer
	controlled rb: Integer

	static t: Seq(Seq(Station))
	static a: Seq(Seq(Constraint))
	static b: Seq(Seq(Constraint))
	static la: Integer
	static lb: Integer

definitions:
	domain Station = {1..27}
	domain Train = {0n..7n}
	domain Constraint = {-1..1}

	// train missions
	function t =
		[[1,   9, 10, 13, 15, 20, 23],
		 [3,   9, 10, 13, 15, 20, 24],
		 [5,  27, 11, 13, 16, 20, 25],
		 [7,  27, 11, 13, 16, 20, 26],
		 [23, 22, 17, 18, 11,  9,  2],
		 [24, 22, 17, 18, 11,  9,  4],
		 [25, 22, 17, 18, 12, 27,  6],
		 [26, 22, 17, 18, 12, 27,  8]]
	// region A train constraints
	function a =
		[[0, 0, 0,  1,  0, -1, 0],
		 [0, 0, 0,  1,  0, -1, 0],
		 [0, 0, 1, -1,  0,  1, 0],
		 [0, 0, 1, -1,  0,  0, 0],
		 [0, 1, 0,  0, -1,  0, 0],
		 [0, 1, 0,  0, -1,  0, 0],
		 [0, 0, 0, -1,  0,  0, 0],
		 [0, 1, 0, -1,  0,  0, 0]]
	// region B train constraints
	function b =
		[[0, 0, 0,  1,  0, -1, 0],
		 [0, 0, 0,  1,  0, -1, 0],
		 [0, 0, 1, -1,  0,  0, 0],
		 [0, 0, 1, -1,  0,  1, 0],
		 [0, 1, 0,  0, -1,  0, 0],
		 [0, 1, 0,  0, -1,  0, 0],
		 [0, 1, 0, -1,  0,  0, 0],
		 [0, 0, 0, -1,  0,  0, 0]]
	function la = 7
	function lb = 7

	// invariant over sseq: eq(indexOf(sseq, CROSS), 1)

	rule r_move_train =
		if (lt(at(p, ct), 6n)
				and	(forall $t in Train with $t != ct implies
						at(at(t, ct), at(p, ct) + 1n) != at(at(t, $t), at(p, $t)))
				and at(at(a, ct), at(p, ct) + 1n) <= la
				and	at(at(b, ct), at(p, ct) + 1n) <= lb) then
			par
				p := replaceAt(p, ct, at(p, ct) + 1n)
				ra := ra + at(at(a, ct), at(p, ct))
				rb := rb + at(at(b, ct), at(p, ct))
			endpar
		endif

	main rule r_Main = r_move_train[]

default init s0:
	function p = [0n, 0n, 0n, 0n, 0n, 0n, 0n, 0n]
	function ra = 1
	function rb = 1
