open util/integer 

open util/steps[Snapshot]
open util/ordering[Snapshot]

// Snapshot definition
    sig Snapshot extends BaseSnapshot {
        Deadlock_ct : one Train
    }

/***************************** STATE SPACE ************************************/
    abstract sig SystemState extends StateLabel {}
    one sig Deadlock extends SystemState {}

/*************************** TRANSITIONS SPACE ********************************/
    one sig Deadlock_move_train0 extends TransitionLabel {}

    // Transition Deadlock_move_train0
    pred pre_Deadlock_move_train0[s:Snapshot] {
        Deadlock in s.conf
        {
            (s.Deadlock_ct) = t0
        }
    }

    pred pos_Deadlock_move_train0[s, s':Snapshot] {
        s'.conf = s.conf - Deadlock + {
            Deadlock
        }
        {
            (s'.Deadlock_ct) = t1
            (s'.Deadlock_ct) = t2
        }
    }

    pred Deadlock_move_train0[s, s': Snapshot] {
        pre_Deadlock_move_train0[s]
        pos_Deadlock_move_train0[s, s']
        semantics_Deadlock_move_train0[s, s']
    }
    pred semantics_Deadlock_move_train0[s, s': Snapshot] {
        s'.taken = Deadlock_move_train0
    }
/****************************** INITIAL CONDITIONS ****************************/
    pred init[s: Snapshot] {
        s.conf = {
            Deadlock
        }
        no s.taken
        // Model specific constraints
        (s.Deadlock_ct) = t0
    }


/***************************** MODEL DEFINITION *******************************/
    pred operation[s, s': Snapshot] {
        Deadlock_move_train0[s, s']
    }

    pred small_step[s, s': Snapshot] {
        operation[s, s']
    }

    pred equals[s, s': Snapshot] {
        s'.conf = s.conf
        s'.taken = s.taken
        // Model specific declarations
        s'.Deadlock_ct = s.Deadlock_ct
    }

    fact {
        all s: Snapshot | s in initial iff init[s]
        all s, s': Snapshot | s->s' in nextStep iff small_step[s, s']
        all s, s': Snapshot | equals[s, s'] => s = s'
        path
    }

    pred path {
        all s:Snapshot, s': s.next | operation[s, s']
        init[first]
    }
    run path for 5 Snapshot, 0 EventLabel
        expect 1



    abstract sig Train {}
    
    one sig t0, t1, t2, t3, t4, t5, t6, t7 extends Train {}
    
    pred trains_eventually_finish  {
        ctl_mc[ef[{ s: Snapshot | {
            (s.Deadlock_ct) = t1
        }
        }]]
    }
    
    run trains_eventually_finish 
        for 2 Snapshot, 0 EventLabel
    
    assert assert_ltl  {
        trains_eventually_finish
    }
    
    check assert_ltl 
        for 30 Snapshot, 0 EventLabel
    

