open util/integer 

open util/steps[Snapshot]
open util/ordering[Snapshot]

// Snapshot definition
    sig Snapshot extends BaseSnapshot {
        Deadlock_P1 : one {
            0 + 1 + 2 + 3 + 4 + 5 + 6
        },
        Deadlock_P5 : one {
            0 + 1 + 2 + 3 + 4 + 5 + 6
        },
        Deadlock_P7 : one {
            0 + 1 + 2 + 3 + 4 + 5 + 6
        },
        Deadlock_P3 : one {
            0 + 1 + 2 + 3 + 4 + 5 + 6
        },
        Deadlock_P0 : one {
            0 + 1 + 2 + 3 + 4 + 5 + 6
        },
        Deadlock_RB : one {
            0 + 1 + 2 + 3 + 4 + 5 + 6 + 7 + 8
        },
        Deadlock_ct : one Train,
        Deadlock_P2 : one {
            0 + 1 + 2 + 3 + 4 + 5 + 6
        },
        Deadlock_P6 : one {
            0 + 1 + 2 + 3 + 4 + 5 + 6
        },
        Deadlock_RA : one {
            0 + 1 + 2 + 3 + 4 + 5 + 6 + 7 + 8
        },
        Deadlock_P4 : one {
            0 + 1 + 2 + 3 + 4 + 5 + 6
        }
    }

/***************************** STATE SPACE ************************************/
    abstract sig SystemState extends StateLabel {}
    one sig Deadlock extends SystemState {}

/*************************** TRANSITIONS SPACE ********************************/
    one sig Deadlock_move_train0 extends TransitionLabel {}
    one sig Deadlock_move_train1 extends TransitionLabel {}
    one sig Deadlock_move_train2 extends TransitionLabel {}
    one sig Deadlock_move_train3 extends TransitionLabel {}
    one sig Deadlock_move_train4 extends TransitionLabel {}
    one sig Deadlock_move_train5 extends TransitionLabel {}
    one sig Deadlock_move_train6 extends TransitionLabel {}
    one sig Deadlock_move_train7 extends TransitionLabel {}
    one sig Deadlock_choose_train extends TransitionLabel {}

    // Transition Deadlock_move_train0
    pred pre_Deadlock_move_train0[s:Snapshot] {
        Deadlock in s.conf
        {
            (s.Deadlock_ct) = t0
            (s.Deadlock_P0) < 6
            Const.T0[ ((s.Deadlock_P0).plus[ 1])] != Const.T1[ (s.Deadlock_P1)] and Const.T0[ ((s.Deadlock_P0).plus[ 1])] != Const.T2[ (s.Deadlock_P2)] and Const.T0[ ((s.Deadlock_P0).plus[ 1])] != Const.T3[ (s.Deadlock_P3)] and Const.T0[ ((s.Deadlock_P0).plus[ 1])] != Const.T4[ (s.Deadlock_P4)] and Const.T0[ ((s.Deadlock_P0).plus[ 1])] != Const.T5[ (s.Deadlock_P5)] and Const.T0[ ((s.Deadlock_P0).plus[ 1])] != Const.T6[ (s.Deadlock_P6)] and Const.T0[ ((s.Deadlock_P0).plus[ 1])] != Const.T7[ (s.Deadlock_P7)]
            ((s.Deadlock_RA).plus[ (Const.A0[ ((s.Deadlock_P0).plus[ 1])])]).lte[ 7]
            ((s.Deadlock_RB).plus[ (Const.B0[ ((s.Deadlock_P0).plus[ 1])])]).lte[ 7]
        }
    }

    pred pos_Deadlock_move_train0[s, s':Snapshot] {
        s'.conf = s.conf - Deadlock + {
            Deadlock
        }
        s'.Deadlock_P1 = s.Deadlock_P1
        s'.Deadlock_P5 = s.Deadlock_P5
        s'.Deadlock_P7 = s.Deadlock_P7
        s'.Deadlock_P3 = s.Deadlock_P3
        s'.Deadlock_ct = s.Deadlock_ct
        s'.Deadlock_P2 = s.Deadlock_P2
        s'.Deadlock_P6 = s.Deadlock_P6
        s'.Deadlock_P4 = s.Deadlock_P4
        {
            (s'.Deadlock_P0) = (s.Deadlock_P0).plus[ 1]
            (s'.Deadlock_RA) = (s.Deadlock_RA).plus[ (Const.A0[ (s'.Deadlock_P0)])]
            (s'.Deadlock_RB) = (s.Deadlock_RB).plus[ (Const.B0[ (s'.Deadlock_P0)])]
        }
    }

    pred Deadlock_move_train0[s, s': Snapshot] {
        pre_Deadlock_move_train0[s]
        pos_Deadlock_move_train0[s, s']
        semantics_Deadlock_move_train0[s, s']
    }
    pred semantics_Deadlock_move_train0[s, s': Snapshot] {
        s'.taken = Deadlock_move_train0
    }
    // Transition Deadlock_move_train1
    pred pre_Deadlock_move_train1[s:Snapshot] {
        Deadlock in s.conf
        {
            (s.Deadlock_ct) = t1
            (s.Deadlock_P1) < 6
            Const.T1[ ((s.Deadlock_P1).plus[ 1])] != Const.T0[ (s.Deadlock_P0)] and Const.T1[ ((s.Deadlock_P1).plus[ 1])] != Const.T2[ (s.Deadlock_P2)] and Const.T1[ ((s.Deadlock_P1).plus[ 1])] != Const.T3[ (s.Deadlock_P3)] and Const.T1[ ((s.Deadlock_P1).plus[ 1])] != Const.T4[ (s.Deadlock_P4)] and Const.T1[ ((s.Deadlock_P1).plus[ 1])] != Const.T5[ (s.Deadlock_P5)] and Const.T1[ ((s.Deadlock_P1).plus[ 1])] != Const.T6[ (s.Deadlock_P6)] and Const.T1[ ((s.Deadlock_P1).plus[ 1])] != Const.T7[ (s.Deadlock_P7)]
            ((s.Deadlock_RA).plus[ (Const.A1[ ((s.Deadlock_P1).plus[ 1])])]).lte[ 7]
            ((s.Deadlock_RB).plus[ (Const.B1[ ((s.Deadlock_P1).plus[ 1])])]).lte[ 7]
        }
    }

    pred pos_Deadlock_move_train1[s, s':Snapshot] {
        s'.conf = s.conf - Deadlock + {
            Deadlock
        }
        s'.Deadlock_P5 = s.Deadlock_P5
        s'.Deadlock_P7 = s.Deadlock_P7
        s'.Deadlock_P3 = s.Deadlock_P3
        s'.Deadlock_P0 = s.Deadlock_P0
        s'.Deadlock_ct = s.Deadlock_ct
        s'.Deadlock_P2 = s.Deadlock_P2
        s'.Deadlock_P6 = s.Deadlock_P6
        s'.Deadlock_P4 = s.Deadlock_P4
        {
            (s'.Deadlock_P1) = (s.Deadlock_P1).plus[ 1]
            (s'.Deadlock_RA) = (s.Deadlock_RA).plus[ (Const.A1[ (s'.Deadlock_P1)])]
            (s'.Deadlock_RB) = (s.Deadlock_RB).plus[ (Const.B1[ (s'.Deadlock_P1)])]
        }
    }

    pred Deadlock_move_train1[s, s': Snapshot] {
        pre_Deadlock_move_train1[s]
        pos_Deadlock_move_train1[s, s']
        semantics_Deadlock_move_train1[s, s']
    }
    pred semantics_Deadlock_move_train1[s, s': Snapshot] {
        s'.taken = Deadlock_move_train1
    }
    // Transition Deadlock_move_train2
    pred pre_Deadlock_move_train2[s:Snapshot] {
        Deadlock in s.conf
        {
            (s.Deadlock_ct) = t2
            (s.Deadlock_P2) < 6
            Const.T2[ ((s.Deadlock_P2).plus[ 1])] != Const.T0[ (s.Deadlock_P0)] and Const.T2[ ((s.Deadlock_P2).plus[ 1])] != Const.T1[ (s.Deadlock_P1)] and Const.T2[ ((s.Deadlock_P2).plus[ 1])] != Const.T3[ (s.Deadlock_P3)] and Const.T2[ ((s.Deadlock_P2).plus[ 1])] != Const.T4[ (s.Deadlock_P4)] and Const.T2[ ((s.Deadlock_P2).plus[ 1])] != Const.T5[ (s.Deadlock_P5)] and Const.T2[ ((s.Deadlock_P2).plus[ 1])] != Const.T6[ (s.Deadlock_P6)] and Const.T2[ ((s.Deadlock_P2).plus[ 1])] != Const.T7[ (s.Deadlock_P7)]
            ((s.Deadlock_RA).plus[ (Const.A2[ ((s.Deadlock_P2).plus[ 1])])]).lte[ 7]
            ((s.Deadlock_RB).plus[ (Const.B2[ ((s.Deadlock_P2).plus[ 1])])]).lte[ 7]
        }
    }

    pred pos_Deadlock_move_train2[s, s':Snapshot] {
        s'.conf = s.conf - Deadlock + {
            Deadlock
        }
        s'.Deadlock_P1 = s.Deadlock_P1
        s'.Deadlock_P5 = s.Deadlock_P5
        s'.Deadlock_P7 = s.Deadlock_P7
        s'.Deadlock_P3 = s.Deadlock_P3
        s'.Deadlock_P0 = s.Deadlock_P0
        s'.Deadlock_ct = s.Deadlock_ct
        s'.Deadlock_P6 = s.Deadlock_P6
        s'.Deadlock_P4 = s.Deadlock_P4
        {
            (s'.Deadlock_P2) = (s.Deadlock_P2).plus[ 1]
            (s'.Deadlock_RA) = (s.Deadlock_RA).plus[ (Const.A2[ (s'.Deadlock_P2)])]
            (s'.Deadlock_RB) = (s.Deadlock_RB).plus[ (Const.B2[ (s'.Deadlock_P2)])]
        }
    }

    pred Deadlock_move_train2[s, s': Snapshot] {
        pre_Deadlock_move_train2[s]
        pos_Deadlock_move_train2[s, s']
        semantics_Deadlock_move_train2[s, s']
    }
    pred semantics_Deadlock_move_train2[s, s': Snapshot] {
        s'.taken = Deadlock_move_train2
    }
    // Transition Deadlock_move_train3
    pred pre_Deadlock_move_train3[s:Snapshot] {
        Deadlock in s.conf
        {
            (s.Deadlock_ct) = t3
            (s.Deadlock_P3) < 6
            Const.T3[ ((s.Deadlock_P3).plus[ 1])] != Const.T0[ (s.Deadlock_P0)] and Const.T3[ ((s.Deadlock_P3).plus[ 1])] != Const.T1[ (s.Deadlock_P1)] and Const.T3[ ((s.Deadlock_P3).plus[ 1])] != Const.T2[ (s.Deadlock_P2)] and Const.T3[ ((s.Deadlock_P3).plus[ 1])] != Const.T4[ (s.Deadlock_P4)] and Const.T3[ ((s.Deadlock_P3).plus[ 1])] != Const.T5[ (s.Deadlock_P5)] and Const.T3[ ((s.Deadlock_P3).plus[ 1])] != Const.T6[ (s.Deadlock_P6)] and Const.T3[ ((s.Deadlock_P3).plus[ 1])] != Const.T7[ (s.Deadlock_P7)]
            ((s.Deadlock_RA).plus[ (Const.A3[ ((s.Deadlock_P3).plus[ 1])])]).lte[ 7]
            ((s.Deadlock_RB).plus[ (Const.B3[ ((s.Deadlock_P3).plus[ 1])])]).lte[ 7]
        }
    }

    pred pos_Deadlock_move_train3[s, s':Snapshot] {
        s'.conf = s.conf - Deadlock + {
            Deadlock
        }
        s'.Deadlock_P1 = s.Deadlock_P1
        s'.Deadlock_P5 = s.Deadlock_P5
        s'.Deadlock_P7 = s.Deadlock_P7
        s'.Deadlock_P0 = s.Deadlock_P0
        s'.Deadlock_ct = s.Deadlock_ct
        s'.Deadlock_P2 = s.Deadlock_P2
        s'.Deadlock_P6 = s.Deadlock_P6
        s'.Deadlock_P4 = s.Deadlock_P4
        {
            (s'.Deadlock_P3) = (s.Deadlock_P3).plus[ 1]
            (s'.Deadlock_RA) = (s.Deadlock_RA).plus[ (Const.A3[ (s'.Deadlock_P3)])]
            (s'.Deadlock_RB) = (s.Deadlock_RB).plus[ (Const.B3[ (s'.Deadlock_P3)])]
        }
    }

    pred Deadlock_move_train3[s, s': Snapshot] {
        pre_Deadlock_move_train3[s]
        pos_Deadlock_move_train3[s, s']
        semantics_Deadlock_move_train3[s, s']
    }
    pred semantics_Deadlock_move_train3[s, s': Snapshot] {
        s'.taken = Deadlock_move_train3
    }
    // Transition Deadlock_move_train4
    pred pre_Deadlock_move_train4[s:Snapshot] {
        Deadlock in s.conf
        {
            (s.Deadlock_ct) = t4
            (s.Deadlock_P4) < 6
            Const.T4[ ((s.Deadlock_P4).plus[ 1])] != Const.T0[ (s.Deadlock_P0)] and Const.T4[ ((s.Deadlock_P4).plus[ 1])] != Const.T1[ (s.Deadlock_P1)] and Const.T4[ ((s.Deadlock_P4).plus[ 1])] != Const.T2[ (s.Deadlock_P2)] and Const.T4[ ((s.Deadlock_P4).plus[ 1])] != Const.T3[ (s.Deadlock_P3)] and Const.T4[ ((s.Deadlock_P4).plus[ 1])] != Const.T5[ (s.Deadlock_P5)] and Const.T4[ ((s.Deadlock_P4).plus[ 1])] != Const.T6[ (s.Deadlock_P6)] and Const.T4[ ((s.Deadlock_P4).plus[ 1])] != Const.T7[ (s.Deadlock_P7)]
            ((s.Deadlock_RA).plus[ (Const.A4[ ((s.Deadlock_P4).plus[ 1])])]).lte[ 7]
            ((s.Deadlock_RB).plus[ (Const.B4[ ((s.Deadlock_P4).plus[ 1])])]).lte[ 7]
        }
    }

    pred pos_Deadlock_move_train4[s, s':Snapshot] {
        s'.conf = s.conf - Deadlock + {
            Deadlock
        }
        s'.Deadlock_P1 = s.Deadlock_P1
        s'.Deadlock_P5 = s.Deadlock_P5
        s'.Deadlock_P7 = s.Deadlock_P7
        s'.Deadlock_P3 = s.Deadlock_P3
        s'.Deadlock_P0 = s.Deadlock_P0
        s'.Deadlock_ct = s.Deadlock_ct
        s'.Deadlock_P2 = s.Deadlock_P2
        s'.Deadlock_P6 = s.Deadlock_P6
        {
            (s'.Deadlock_P4) = (s.Deadlock_P4).plus[ 1]
            (s'.Deadlock_RA) = (s.Deadlock_RA).plus[ (Const.A4[ (s'.Deadlock_P4)])]
            (s'.Deadlock_RB) = (s.Deadlock_RB).plus[ (Const.B4[ (s'.Deadlock_P4)])]
        }
    }

    pred Deadlock_move_train4[s, s': Snapshot] {
        pre_Deadlock_move_train4[s]
        pos_Deadlock_move_train4[s, s']
        semantics_Deadlock_move_train4[s, s']
    }
    pred semantics_Deadlock_move_train4[s, s': Snapshot] {
        s'.taken = Deadlock_move_train4
    }
    // Transition Deadlock_move_train5
    pred pre_Deadlock_move_train5[s:Snapshot] {
        Deadlock in s.conf
        {
            (s.Deadlock_ct) = t5
            (s.Deadlock_P5) < 6
            Const.T5[ ((s.Deadlock_P5).plus[ 1])] != Const.T0[ (s.Deadlock_P0)] and Const.T5[ ((s.Deadlock_P5).plus[ 1])] != Const.T1[ (s.Deadlock_P1)] and Const.T5[ ((s.Deadlock_P5).plus[ 1])] != Const.T2[ (s.Deadlock_P2)] and Const.T5[ ((s.Deadlock_P5).plus[ 1])] != Const.T3[ (s.Deadlock_P3)] and Const.T5[ ((s.Deadlock_P5).plus[ 1])] != Const.T4[ (s.Deadlock_P4)] and Const.T5[ ((s.Deadlock_P5).plus[ 1])] != Const.T6[ (s.Deadlock_P6)] and Const.T5[ ((s.Deadlock_P5).plus[ 1])] != Const.T7[ (s.Deadlock_P7)]
            ((s.Deadlock_RA).plus[ (Const.A5[ ((s.Deadlock_P5).plus[ 1])])]).lte[ 7]
            ((s.Deadlock_RB).plus[ (Const.B5[ ((s.Deadlock_P5).plus[ 1])])]).lte[ 7]
        }
    }

    pred pos_Deadlock_move_train5[s, s':Snapshot] {
        s'.conf = s.conf - Deadlock + {
            Deadlock
        }
        s'.Deadlock_P1 = s.Deadlock_P1
        s'.Deadlock_P7 = s.Deadlock_P7
        s'.Deadlock_P3 = s.Deadlock_P3
        s'.Deadlock_P0 = s.Deadlock_P0
        s'.Deadlock_ct = s.Deadlock_ct
        s'.Deadlock_P2 = s.Deadlock_P2
        s'.Deadlock_P6 = s.Deadlock_P6
        s'.Deadlock_P4 = s.Deadlock_P4
        {
            (s'.Deadlock_P5) = (s.Deadlock_P5).plus[ 1]
            (s'.Deadlock_RA) = (s.Deadlock_RA).plus[ (Const.A5[ (s'.Deadlock_P5)])]
            (s'.Deadlock_RB) = (s.Deadlock_RB).plus[ (Const.B5[ (s'.Deadlock_P5)])]
        }
    }

    pred Deadlock_move_train5[s, s': Snapshot] {
        pre_Deadlock_move_train5[s]
        pos_Deadlock_move_train5[s, s']
        semantics_Deadlock_move_train5[s, s']
    }
    pred semantics_Deadlock_move_train5[s, s': Snapshot] {
        s'.taken = Deadlock_move_train5
    }
    // Transition Deadlock_move_train6
    pred pre_Deadlock_move_train6[s:Snapshot] {
        Deadlock in s.conf
        {
            (s.Deadlock_ct) = t6
            (s.Deadlock_P6) < 6
            Const.T6[ ((s.Deadlock_P6).plus[ 1])] != Const.T0[ (s.Deadlock_P0)] and Const.T6[ ((s.Deadlock_P6).plus[ 1])] != Const.T1[ (s.Deadlock_P1)] and Const.T6[ ((s.Deadlock_P6).plus[ 1])] != Const.T2[ (s.Deadlock_P2)] and Const.T6[ ((s.Deadlock_P6).plus[ 1])] != Const.T3[ (s.Deadlock_P3)] and Const.T6[ ((s.Deadlock_P6).plus[ 1])] != Const.T4[ (s.Deadlock_P4)] and Const.T6[ ((s.Deadlock_P6).plus[ 1])] != Const.T5[ (s.Deadlock_P5)] and Const.T6[ ((s.Deadlock_P6).plus[ 1])] != Const.T7[ (s.Deadlock_P7)]
            ((s.Deadlock_RA).plus[ (Const.A6[ ((s.Deadlock_P6).plus[ 1])])]).lte[ 7]
            ((s.Deadlock_RB).plus[ (Const.B6[ ((s.Deadlock_P6).plus[ 1])])]).lte[ 7]
        }
    }

    pred pos_Deadlock_move_train6[s, s':Snapshot] {
        s'.conf = s.conf - Deadlock + {
            Deadlock
        }
        s'.Deadlock_P1 = s.Deadlock_P1
        s'.Deadlock_P5 = s.Deadlock_P5
        s'.Deadlock_P7 = s.Deadlock_P7
        s'.Deadlock_P3 = s.Deadlock_P3
        s'.Deadlock_P0 = s.Deadlock_P0
        s'.Deadlock_ct = s.Deadlock_ct
        s'.Deadlock_P2 = s.Deadlock_P2
        s'.Deadlock_P4 = s.Deadlock_P4
        {
            (s'.Deadlock_P6) = (s.Deadlock_P6).plus[ 1]
            (s'.Deadlock_RA) = (s.Deadlock_RA).plus[ (Const.A6[ (s'.Deadlock_P6)])]
            (s'.Deadlock_RB) = (s.Deadlock_RB).plus[ (Const.B6[ (s'.Deadlock_P6)])]
        }
    }

    pred Deadlock_move_train6[s, s': Snapshot] {
        pre_Deadlock_move_train6[s]
        pos_Deadlock_move_train6[s, s']
        semantics_Deadlock_move_train6[s, s']
    }
    pred semantics_Deadlock_move_train6[s, s': Snapshot] {
        s'.taken = Deadlock_move_train6
    }
    // Transition Deadlock_move_train7
    pred pre_Deadlock_move_train7[s:Snapshot] {
        Deadlock in s.conf
        {
            (s.Deadlock_ct) = t7
            (s.Deadlock_P7) < 6
            Const.T7[ ((s.Deadlock_P7).plus[ 1])] != Const.T0[ (s.Deadlock_P0)] and Const.T7[ ((s.Deadlock_P7).plus[ 1])] != Const.T1[ (s.Deadlock_P1)] and Const.T7[ ((s.Deadlock_P7).plus[ 1])] != Const.T2[ (s.Deadlock_P2)] and Const.T7[ ((s.Deadlock_P7).plus[ 1])] != Const.T3[ (s.Deadlock_P3)] and Const.T7[ ((s.Deadlock_P7).plus[ 1])] != Const.T4[ (s.Deadlock_P4)] and Const.T7[ ((s.Deadlock_P7).plus[ 1])] != Const.T5[ (s.Deadlock_P5)] and Const.T7[ ((s.Deadlock_P7).plus[ 1])] != Const.T6[ (s.Deadlock_P6)]
            ((s.Deadlock_RA).plus[ (Const.A7[ ((s.Deadlock_P7).plus[ 1])])]).lte[ 7]
            ((s.Deadlock_RB).plus[ (Const.B7[ ((s.Deadlock_P7).plus[ 1])])]).lte[ 7]
        }
    }

    pred pos_Deadlock_move_train7[s, s':Snapshot] {
        s'.conf = s.conf - Deadlock + {
            Deadlock
        }
        s'.Deadlock_P1 = s.Deadlock_P1
        s'.Deadlock_P5 = s.Deadlock_P5
        s'.Deadlock_P3 = s.Deadlock_P3
        s'.Deadlock_P0 = s.Deadlock_P0
        s'.Deadlock_ct = s.Deadlock_ct
        s'.Deadlock_P2 = s.Deadlock_P2
        s'.Deadlock_P6 = s.Deadlock_P6
        s'.Deadlock_P4 = s.Deadlock_P4
        {
            (s'.Deadlock_P7) = (s.Deadlock_P7).plus[ 1]
            (s'.Deadlock_RA) = (s.Deadlock_RA).plus[ (Const.A7[ (s'.Deadlock_P7)])]
            (s'.Deadlock_RB) = (s.Deadlock_RB).plus[ (Const.B7[ (s'.Deadlock_P7)])]
        }
    }

    pred Deadlock_move_train7[s, s': Snapshot] {
        pre_Deadlock_move_train7[s]
        pos_Deadlock_move_train7[s, s']
        semantics_Deadlock_move_train7[s, s']
    }
    pred semantics_Deadlock_move_train7[s, s': Snapshot] {
        s'.taken = Deadlock_move_train7
    }
    // Transition Deadlock_choose_train
    pred pre_Deadlock_choose_train[s:Snapshot] {
        Deadlock in s.conf
    }

    pred pos_Deadlock_choose_train[s, s':Snapshot] {
        s'.conf = s.conf - Deadlock + {
            Deadlock
        }
        s'.Deadlock_P1 = s.Deadlock_P1
        s'.Deadlock_P5 = s.Deadlock_P5
        s'.Deadlock_P7 = s.Deadlock_P7
        s'.Deadlock_P3 = s.Deadlock_P3
        s'.Deadlock_P0 = s.Deadlock_P0
        s'.Deadlock_RB = s.Deadlock_RB
        s'.Deadlock_P2 = s.Deadlock_P2
        s'.Deadlock_P6 = s.Deadlock_P6
        s'.Deadlock_RA = s.Deadlock_RA
        s'.Deadlock_P4 = s.Deadlock_P4
        {
            ((s.Deadlock_ct) = t0 and (s'.Deadlock_ct) = t1) or ((s.Deadlock_ct) = t1 and (s'.Deadlock_ct) = t2) or ((s.Deadlock_ct) = t2 and (s'.Deadlock_ct) = t3) or ((s.Deadlock_ct) = t3 and (s'.Deadlock_ct) = t4) or ((s.Deadlock_ct) = t4 and (s'.Deadlock_ct) = t5) or ((s.Deadlock_ct) = t5 and (s'.Deadlock_ct) = t6) or ((s.Deadlock_ct) = t6 and (s'.Deadlock_ct) = t7) or ((s.Deadlock_ct) = t7 and (s'.Deadlock_ct) = t0)
        }
    }

    pred Deadlock_choose_train[s, s': Snapshot] {
        pre_Deadlock_choose_train[s]
        pos_Deadlock_choose_train[s, s']
        semantics_Deadlock_choose_train[s, s']
    }
    pred semantics_Deadlock_choose_train[s, s': Snapshot] {
        s'.taken = Deadlock_choose_train
    }
/****************************** INITIAL CONDITIONS ****************************/
    pred init[s: Snapshot] {
        s.conf = {
            Deadlock
        }
        no s.taken
        // Model specific constraints
        (s.Deadlock_P0) = 0
            (s.Deadlock_P1) = 0
            (s.Deadlock_P2) = 0
            (s.Deadlock_P3) = 0
            (s.Deadlock_P4) = 0
            (s.Deadlock_P5) = 0
            (s.Deadlock_P6) = 0
            (s.Deadlock_P7) = 0
            (s.Deadlock_RA) = 1
            (s.Deadlock_RB) = 1
    }


/***************************** MODEL DEFINITION *******************************/
    pred operation[s, s': Snapshot] {
        Deadlock_move_train0[s, s'] or
        Deadlock_move_train1[s, s'] or
        Deadlock_move_train2[s, s'] or
        Deadlock_move_train3[s, s'] or
        Deadlock_move_train4[s, s'] or
        Deadlock_move_train5[s, s'] or
        Deadlock_move_train6[s, s'] or
        Deadlock_move_train7[s, s'] or
        Deadlock_choose_train[s, s']
    }

    pred small_step[s, s': Snapshot] {
        operation[s, s']
    }

    pred equals[s, s': Snapshot] {
        s'.conf = s.conf
        s'.taken = s.taken
        // Model specific declarations
        s'.Deadlock_P1 = s.Deadlock_P1
        s'.Deadlock_P5 = s.Deadlock_P5
        s'.Deadlock_P7 = s.Deadlock_P7
        s'.Deadlock_P3 = s.Deadlock_P3
        s'.Deadlock_P0 = s.Deadlock_P0
        s'.Deadlock_RB = s.Deadlock_RB
        s'.Deadlock_ct = s.Deadlock_ct
        s'.Deadlock_P2 = s.Deadlock_P2
        s'.Deadlock_P6 = s.Deadlock_P6
        s'.Deadlock_RA = s.Deadlock_RA
        s'.Deadlock_P4 = s.Deadlock_P4
    }

    fact {
        all s: Snapshot | s in initial iff init[s]
        all s, s': Snapshot | s->s' in nextStep iff small_step[s, s']
        all s, s': Snapshot | equals[s, s'] => s = s'
        path
    }

    pred path {
        all s:Snapshot, s': s.next | operation[s, s']
        init[first]
    }
    run path for 5 Snapshot, 0 EventLabel
        expect 1

/****************************** INVARIANTS ************************************/
    fact Deadlock_constants {
        all s: Snapshot | Deadlock in s.conf => {
            Const.T0 = {
                    0 -> s1 + 1 -> s9 + 2 -> s10 + 3 -> s13 + 4 -> s15 + 5 -> s20 + 6 -> s23
                }
                Const.T1 = {
                    0 -> s3 + 1 -> s9 + 2 -> s10 + 3 -> s13 + 4 -> s15 + 5 -> s20 + 6 -> s24
                }
                Const.T2 = {
                    0 -> s5 + 1 -> s27 + 2 -> s11 + 3 -> s13 + 4 -> s16 + 5 -> s20 + 6 -> s25
                }
                Const.T3 = {
                    0 -> s7 + 1 -> s27 + 2 -> s11 + 3 -> s13 + 4 -> s16 + 5 -> s20 + 6 -> s26
                }
                Const.T4 = {
                    0 -> s23 + 1 -> s22 + 2 -> s17 + 3 -> s18 + 4 -> s11 + 5 -> s9 + 6 -> s2
                }
                Const.T5 = {
                    0 -> s24 + 1 -> s22 + 2 -> s17 + 3 -> s18 + 4 -> s11 + 5 -> s9 + 6 -> s4
                }
                Const.T6 = {
                    0 -> s25 + 1 -> s22 + 2 -> s17 + 3 -> s18 + 4 -> s12 + 5 -> s27 + 6 -> s6
                }
                Const.T7 = {
                    0 -> s26 + 1 -> s22 + 2 -> s17 + 3 -> s18 + 4 -> s12 + 5 -> s27 + 6 -> s8
                }
                Const.A0 = {
                    0 -> 0 + 1 -> 0 + 2 -> 0 + 3 -> 1 + 4 -> 0 + 5 -> -1 + 6 -> 0
                }
                Const.A1 = {
                    0 -> 0 + 1 -> 0 + 2 -> 0 + 3 -> 1 + 4 -> 0 + 5 -> -1 + 6 -> 0
                }
                Const.A2 = {
                    0 -> 0 + 1 -> 0 + 2 -> 1 + 3 -> -1 + 4 -> 0 + 5 -> 1 + 6 -> 0
                }
                Const.A3 = {
                    0 -> 0 + 1 -> 0 + 2 -> 1 + 3 -> -1 + 4 -> 0 + 5 -> 0 + 6 -> 0
                }
                Const.A4 = {
                    0 -> 0 + 1 -> 1 + 2 -> 0 + 3 -> 0 + 4 -> -1 + 5 -> 0 + 6 -> 0
                }
                Const.A5 = {
                    0 -> 0 + 1 -> 1 + 2 -> 0 + 3 -> 0 + 4 -> -1 + 5 -> 0 + 6 -> 0
                }
                Const.A6 = {
                    0 -> 0 + 1 -> 0 + 2 -> 0 + 3 -> -1 + 4 -> 0 + 5 -> 0 + 6 -> 0
                }
                Const.A7 = {
                    0 -> 0 + 1 -> 1 + 2 -> 0 + 3 -> -1 + 4 -> 0 + 5 -> 0 + 6 -> 0
                }
                Const.B0 = {
                    0 -> 0 + 1 -> 0 + 2 -> 0 + 3 -> 1 + 4 -> 0 + 5 -> -1 + 6 -> 0
                }
                Const.B1 = {
                    0 -> 0 + 1 -> 0 + 2 -> 0 + 3 -> 1 + 4 -> 0 + 5 -> -1 + 6 -> 0
                }
                Const.B2 = {
                    0 -> 0 + 1 -> 0 + 2 -> 1 + 3 -> -1 + 4 -> 0 + 5 -> 0 + 6 -> 0
                }
                Const.B3 = {
                    0 -> 0 + 1 -> 0 + 2 -> 1 + 3 -> -1 + 4 -> 0 + 5 -> 1 + 6 -> 0
                }
                Const.B4 = {
                    0 -> 0 + 1 -> 1 + 2 -> 0 + 3 -> 0 + 4 -> -1 + 5 -> 0 + 6 -> 0
                }
                Const.B5 = {
                    0 -> 0 + 1 -> 1 + 2 -> 0 + 3 -> 0 + 4 -> -1 + 5 -> 0 + 6 -> 0
                }
                Const.B6 = {
                    0 -> 0 + 1 -> 1 + 2 -> 0 + 3 -> -1 + 4 -> 0 + 5 -> 0 + 6 -> 0
                }
                Const.B7 = {
                    0 -> 0 + 1 -> 0 + 2 -> 0 + 3 -> -1 + 4 -> 0 + 5 -> 0 + 6 -> 0
                }
        }
    }
    


    abstract sig Train {}
    
    one sig t0, t1, t2, t3, t4, t5, t6, t7 extends Train {}
    
    abstract sig Station {}
    
    one sig s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17, s18, s19, s20, s21, s22, s23, s24, s25, s26, s27 extends Station {}
    
    one sig Const  {
        T0, T1, T2, T3, T4, T5, T6, T7 : {
            0 + 1 + 2 + 3 + 4 + 5 + 6
        }
         -> Station,
        A0, A1, A2, A3, A4, A5, A6, A7, B0, B1, B2, B3, B4, B5, B6, B7 : {
            0 + 1 + 2 + 3 + 4 + 5 + 6
        }
         -> {
            -1 + 0 + 1
        }
     }
    
    pred trains_eventually_finish  {
        ctl_mc[ef[{ s: Snapshot | {
            (s.Deadlock_P0) = 6
            (s.Deadlock_P1) = 6
            (s.Deadlock_P2) = 6
            (s.Deadlock_P3) = 6
            (s.Deadlock_P4) = 6
            (s.Deadlock_P5) = 6
            (s.Deadlock_P6) = 6
            (s.Deadlock_P7) = 6
        }
        }]]
    }
    
    run trains_eventually_finish 
        for 49 Snapshot, 0 EventLabel
    
    assert assert_ltl  {
        trains_eventually_finish
    }
    
    check assert_ltl 
        for 49 Snapshot, 0 EventLabel
    

