-------------------------- MODULE deadlock_pluscal --------------------------
EXTENDS Integers, Sequences, TLC

trains == 0..7
LA == 7
LB == 7

T ==  \* train missions
    ( 0 :> (0:>1  @@ 1:>9  @@ 2:>10 @@ 3:>13 @@ 4:>15 @@ 5:>20 @@ 6:>23) @@
      1 :> (0:>3  @@ 1:>9  @@ 2:>10 @@ 3:>13 @@ 4:>15 @@ 5:>20 @@ 6:>24) @@
      2 :> (0:>5  @@ 1:>27 @@ 2:>11 @@ 3:>13 @@ 4:>16 @@ 5:>20 @@ 6:>25) @@
      3 :> (0:>7  @@ 1:>27 @@ 2:>11 @@ 3:>13 @@ 4:>16 @@ 5:>20 @@ 6:>26) @@
      4 :> (0:>23 @@ 1:>22 @@ 2:>17 @@ 3:>18 @@ 4:>11 @@ 5:>9  @@ 6:>2)  @@
      5 :> (0:>24 @@ 1:>22 @@ 2:>17 @@ 3:>18 @@ 4:>11 @@ 5:>9  @@ 6:>4)  @@
      6 :> (0:>25 @@ 1:>22 @@ 2:>17 @@ 3:>18 @@ 4:>12 @@ 5:>27 @@ 6:>6)  @@
      7 :> (0:>26 @@ 1:>22 @@ 2:>17 @@ 3:>18 @@ 4:>12 @@ 5:>27 @@ 6:>8) )

A ==  \* region A train constraints
    ( 0 :> (0:>0 @@ 1:>0 @@ 2:>0 @@ 3:>1  @@ 4:>0  @@ 5:>-1 @@ 6:>0) @@
      1 :> (0:>0 @@ 1:>0 @@ 2:>0 @@ 3:>1  @@ 4:>0  @@ 5:>-1 @@ 6:>0) @@
      2 :> (0:>0 @@ 1:>0 @@ 2:>1 @@ 3:>-1 @@ 4:>0  @@ 5:>1  @@ 6:>0) @@
      3 :> (0:>0 @@ 1:>0 @@ 2:>1 @@ 3:>-1 @@ 4:>0  @@ 5:>0  @@ 6:>0) @@
      4 :> (0:>0 @@ 1:>1 @@ 2:>0 @@ 3:>0  @@ 4:>-1 @@ 5:>0  @@ 6:>0) @@
      5 :> (0:>0 @@ 1:>1 @@ 2:>0 @@ 3:>0  @@ 4:>-1 @@ 5:>0  @@ 6:>0) @@
      6 :> (0:>0 @@ 1:>0 @@ 2:>0 @@ 3:>-1 @@ 4:>0  @@ 5:>0  @@ 6:>0) @@
      7 :> (0:>0 @@ 1:>1 @@ 2:>0 @@ 3:>-1 @@ 4:>0  @@ 5:>0  @@ 6:>0) )

B ==  \* region B train constraints
    ( 0 :> (0:>0 @@ 1:>0 @@ 2:>0 @@ 3:>1  @@ 4:>0  @@ 5:>-1 @@ 6:>0) @@
      1 :> (0:>0 @@ 1:>0 @@ 2:>0 @@ 3:>1  @@ 4:>0  @@ 5:>-1 @@ 6:>0) @@
      2 :> (0:>0 @@ 1:>0 @@ 2:>1 @@ 3:>-1 @@ 4:>0  @@ 5:>0  @@ 6:>0) @@
      3 :> (0:>0 @@ 1:>0 @@ 2:>1 @@ 3:>-1 @@ 4:>0  @@ 5:>1  @@ 6:>0) @@
      4 :> (0:>0 @@ 1:>1 @@ 2:>0 @@ 3:>0  @@ 4:>-1 @@ 5:>0  @@ 6:>0) @@
      5 :> (0:>0 @@ 1:>1 @@ 2:>0 @@ 3:>0  @@ 4:>-1 @@ 5:>0  @@ 6:>0) @@
      6 :> (0:>0 @@ 1:>1 @@ 2:>0 @@ 3:>-1 @@ 4:>0  @@ 5:>0  @@ 6:>0) @@
      7 :> (0:>0 @@ 1:>0 @@ 2:>0 @@ 3:>-1 @@ 4:>0  @@ 5:>0  @@ 6:>0) )

(* --algorithm deadlock_pluscal
variables P = [t \in trains |-> 0],
          RA = 1,
          RB = 1,
          ct \in trains;

define

TypeOK ==
    /\ P \in [trains -> 0..6]
    /\ RA \in 0..8
    /\ RB \in 0..8
    /\ ct \in trains  \* chosen train

end define

fair+ process move_train = "move_train"
begin
    move_train:
        when
            \* ct hasn't reached end of its mission
            /\ P[ct] < 6
            \* next stop of ct isn't occupied by any other train
            /\ \A t \in trains:
                t # ct => T[ct][P[ct] + 1] # T[t][P[t]]
            \* progress of ct will not saturate A or B
            /\ RA + A[ct][P[ct] + 1] <= LA
            /\ RB + B[ct][P[ct] + 1] <= LB;
        P[ct] := P[ct] + 1;
        RA := RA + A[ct][P[ct]];
        RB := RB + B[ct][P[ct]];
        goto move_train
end process

fair process choose_train = "choose_train"
begin
    choose_train:
        if ct < 7 then
            ct := ct + 1
        else
            ct := 0
        end if;
        goto choose_train
end process

end algorithm *)
\* BEGIN TRANSLATION
\* Label move_train of process move_train at line 57 col 9 changed to move_train_
\* Label choose_train of process choose_train at line 75 col 9 changed to choose_train_
VARIABLES P, RA, RB, ct, pc

(* define statement *)
TypeOK ==
    /\ P \in [trains -> 0..6]
    /\ RA \in 0..8
    /\ RB \in 0..8
    /\ ct \in trains


vars == << P, RA, RB, ct, pc >>

ProcSet == {"move_train"} \cup {"choose_train"}

Init == (* Global variables *)
        /\ P = [t \in trains |-> 0]
        /\ RA = 1
        /\ RB = 1
        /\ ct \in trains
        /\ pc = [self \in ProcSet |-> CASE self = "move_train" -> "move_train_"
                                        [] self = "choose_train" -> "choose_train_"]

move_train_ == /\ pc["move_train"] = "move_train_"
               /\ /\ P[ct] < 6
                  
                  /\ \A t \in trains:
                      t # ct => T[ct][P[ct] + 1] # T[t][P[t]]
                  
                  /\ RA + A[ct][P[ct] + 1] <= LA
                  /\ RB + B[ct][P[ct] + 1] <= LB
               /\ P' = [P EXCEPT ![ct] = P[ct] + 1]
               /\ RA' = RA + A[ct][P'[ct]]
               /\ RB' = RB + B[ct][P'[ct]]
               /\ pc' = [pc EXCEPT !["move_train"] = "move_train_"]
               /\ ct' = ct

move_train == move_train_

choose_train_ == /\ pc["choose_train"] = "choose_train_"
                 /\ IF ct < 7
                       THEN /\ ct' = ct + 1
                       ELSE /\ ct' = 0
                 /\ pc' = [pc EXCEPT !["choose_train"] = "choose_train_"]
                 /\ UNCHANGED << P, RA, RB >>

choose_train == choose_train_

(* Allow infinite stuttering to prevent deadlock on termination. *)
Terminating == /\ \A self \in ProcSet: pc[self] = "Done"
               /\ UNCHANGED vars

Next == move_train \/ choose_train
           \/ Terminating

Spec == /\ Init /\ [][Next]_vars
        /\ SF_vars(move_train)
        /\ WF_vars(choose_train)

Termination == <>(\A self \in ProcSet: pc[self] = "Done")

\* END TRANSLATION

ASSERT_LTL == []<>(\A t \in trains: P[t] = 6)

=============================================================================
\* Modification History
\* Last modified Wed Jan 22 00:05:11 EST 2020 by bandali
\* Created Tue Jan 21 13:23:14 EST 2020 by bandali
