package uw.watform.dash.generator

import org.eclipse.xtend.lib.annotations.Accessors

class ExpressionOptions {
    public static val SNAPSHOT_VAR_NAME = "s"

    /**
     * Used to generate unique variable names to avoid capturing variables in expressions
     */
    static int freshVariableCounter = 0

    @Accessors
    boolean useFreshVar = false

    static def incrementVariableCounter() {
        freshVariableCounter++
    }

    static def getVariableCounter() {
        freshVariableCounter
    }

    new () {
        this.freshVarName = getFreshSnapshotVar()
    }

    static def getFreshSnapshotVar() {
        incrementVariableCounter()
        SNAPSHOT_VAR_NAME + getVariableCounter
    }

    /**
     * Fresh name to use for snapshots
     */
    var String freshVarName

    /**
     * Name to use for snapshots
     */
    var String snapshotVar

    def getSnapshotVar() {
        var name = ""
        if (useFreshVar) {
            name = freshVarName
        } else {
            name = snapshotVar
        }
        return name
    }

    def setSnapshotVar(String snapshotVar) {
        this.snapshotVar = snapshotVar
    }
}