package uw.watform.dash.generator

import com.google.inject.Singleton
import org.eclipse.xtend.lib.annotations.Accessors

@Singleton
class Options {
    /**
     * Indicates whether to use full names for code generation
     */
    @Accessors
    boolean useFullNames = true

    /**
     * Indicates if the single input assumption is made
     */
    @Accessors
    boolean assumeSingleInput = true

    /**
     * Indicates if reachability properties should be generated
     */
    @Accessors
    boolean checkReachability = true

    /**
     * Enables generation of predicates when variables are unconstrained
     */
    @Accessors
    boolean varsUnchanged = true

    /**
     * Enables the generation of enter and exit function to compute the states
     * entered and exited by a transition
     */
    @Accessors
    boolean generateEnterExitFunctions = false

    /**
     * Indicates if constrains to induce a total order of Snapshots is included
     * in the Alloy code to constraint instances to be path based.
     */
    @Accessors
    boolean forcePath = false

    /**
     * Indicates the number of snapshots to consider for the analysis
     */
    @Accessors
    int snapshotScope = 5
}