package uw.watform.dash.generator.elements

import uw.watform.dash.dash.State
import java.util.List

class StateGeneratorElement extends GeneratorElement {
    val NAME_PREFIX = "s"

    List<State> substates

    new (State s) {
        this(s, 0)
    }

    new (State s, int generatorCounter) {
        super(s, generatorCounter)
    }

    override getPrefix () {
        NAME_PREFIX
    }

    def boolean strictlyContains(StateGeneratorElement other) {
        Helper.strictlyContains(node as State, other.node as State)
    }

    def boolean contains(StateGeneratorElement other) {
        Helper.contains(node as State, other.node as State)
    }

    def boolean contains(State other) {
        Helper.contains(node as State, other)
    }

    def boolean isBasicState() {
        getSubstates().empty
    }

    def getSubstates() {
        if (substates === null) {
            substates = (this.node as State).stateItems.filter(State).toList
        }
        return substates
    }

    override State getNode() {
        node as State
    }
}
