package uw.watform.dash.generator.elements

import org.eclipse.emf.common.util.EList
import org.eclipse.emf.common.util.BasicEList
import uw.watform.dash.dash.StateVar
import uw.watform.dash.dash.DashFactory
import uw.watform.dash.dash.DashPackage
import uw.watform.dash.dash.Element

class StateVarGeneratorElement extends GeneratorElement {
    val NAME_PREFIX = "sv"

    // Used to create DASH elements
    DashFactory factory = DashPackage.eINSTANCE.getDashFactory()

    new (StateVar sv) {
        this(sv, 0)
    }

    new (StateVar sv, int generatorCounter) {
        super(sv, generatorCounter)
    }

    override getPrefix () {
        NAME_PREFIX
    }

    def String getName(boolean fullName, String delimiter, Element e) {
        var String name = null
        if ((node as StateVar).decl.names.contains(e)) {
            name = getName(fullName, delimiter, e.name)
        }
        name
    }

    def getName(boolean fullNames, Element e) {
        getName(fullNames, "_", e)
    }

    def getNames(boolean fullNames) {
        getNames(fullNames, "_")
    }

    def getNames(boolean fullNames, String delimiter) {
        var EList<Element> declarationNames = new BasicEList<Element>
        for (name : (node as StateVar).decl.names) {
            var element = factory.createElement
            element.name = getName(fullNames, delimiter, name.name)
            declarationNames.add(element)
        }
        return declarationNames
    }

    def private getName(boolean fullName, String delimiter, String name) {
        if (fullName) {
            var String prefix = ""
            if (longName !== null) {
                prefix = longName.replace(".", delimiter) + delimiter
            }
            return prefix + name
        } else {
            return shortName + delimiter + name
        }
    }

    override StateVar getNode() {
        node as StateVar
    }
}