/*
 * generated by Xtext 2.10.0
 */
package uw.watform.dash.scoping

import org.eclipse.emf.ecore.EObject
import org.eclipse.emf.ecore.EReference
import uw.watform.dash.dash.TransTemplate
import org.eclipse.xtext.EcoreUtil2
import uw.watform.dash.dash.EventQualNames
import org.eclipse.xtext.resource.EObjectDescription
import java.util.List
import uw.watform.dash.dash.StateQualNames
import uw.watform.dash.dash.Declaration
import uw.watform.dash.dash.EventPrimitiveType
import uw.watform.dash.dash.StatePrimitiveType
import uw.watform.dash.dash.PrimitiveType
import org.eclipse.xtext.resource.IEObjectDescription
import org.eclipse.xtext.scoping.IScope
import org.eclipse.xtext.scoping.impl.SimpleScope
import org.eclipse.xtext.naming.QualifiedName

/**
 * This class contains custom scoping description.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#scoping
 * on how and when to use it.
 */
class DashScopeProvider extends AbstractDashScopeProvider {

    override getScope(EObject context, EReference reference) {
        // If inside a template add template parameters to scope
        if (context instanceof StateQualNames || context instanceof EventQualNames) {
            val template = EcoreUtil2.getContainerOfType(context, TransTemplate)
            var scope = super.getScope(context, reference)
            var List<IEObjectDescription> vals = scope.allElements.reject[
                e | e.EObjectOrProxy instanceof Declaration
            ].toList

            if (template !== null) {
                var List<Declaration> decls = null
                if (context instanceof StateQualNames) {
                    decls = template.params.filter[
                        d | declarationFilterPredicate(d, StatePrimitiveType)
                    ].toList
                } else if (context instanceof EventQualNames) {
                    decls = template.params.filter[
                        d | declarationFilterPredicate(d, EventPrimitiveType)
                    ].toList
                }
                // Add declarations
                for (d : decls) {
                    for (name : d.names) {
                        vals.add(EObjectDescription.create(QualifiedName.create(name.name), d))
                    }
                }
            }
            return new SimpleScope(IScope.NULLSCOPE, vals)
        }
        return super.getScope(context, reference);
    }

    private  def <T> boolean declarationFilterPredicate(Declaration d, Class<T> type) {
        d.type instanceof PrimitiveType && type.isInstance((d.type as  PrimitiveType).value)
    }
}
