package uw.watform.dash.transform

import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.emf.ecore.EObject
import org.eclipse.xtend.lib.annotations.Data
import java.util.Map
import uw.watform.dash.generator.elements.GeneratorElement

/**
 * Represents the result of a transformation from a DASH model to a Core DASH model
 */
@Data class Result {
    /**
     * The Core DASH model
     */
    Resource resource

    /**
     * Maps EObjects to their corresponding generator object
     */
    Map<EObject, GeneratorElement> generatorElements

    /**
     * Constructs an immutable TransformResult
     */
    new(Resource res, Map<EObject, GeneratorElement> generatorElements) {
        this.resource = res
        this.generatorElements = generatorElements
    }
}